module
#include "../misc/flags.t"
#include "../misc/misc.t"
#include "../expr/error.t"
#include "../expr/constr.t.t"
#include "../expr/constrfun.t"
#include "../expr/types.t.t"
#include "../expr/id.t.t"
#include "../expr/id.t"
#include "../expr/ttype.t"
#include "../expr/impexp.t.t"
#include "../rename/rename.t"
#include "../transform/match.t"
#include "../transform/constr.t"
#include "../transform/lettrans.t"
#include "../transform/misc.t"
#include "../transform/exprs.t"
#include "../transform/remsign.t"
#include "../transform/remclass.t"
#include "../transform/remlazy.t"
#include "../Expr/Expr.t.t"
#include "../Expr/Ecnv.t"
#include "../Expr/Eprint.t"
#include "../Expr/apconv.t"
#include "../Expr/eqtrans.t"
#include "../Expr/addrestr.t"
#include "../Expr/prexport.t"
#include "../Expr/unrec.t"
#include "../Expr/Eutil.t"
#include "../Expr/classtrans.t"
#include "../type/tchk.t"
#include "../strict/strict.t"
#include "../strict/mkstrict.t"
#include "../strict/strictcon.t"
#include "../simpl/simpl.t"
#include "../curry/curry0.t"
#include "../zf/lmlzf.t"
#include "../zf/remzf.t"
#include "Cexpr.t"
#include "iabs.t"
#include "id.h"
#include "econv.t"
export icomp;
rec icomp e0 autoexp =
    let errmap = [] in
    let e02 = if Curry then curry0 e0 else lmlzf e0 in
    let (u1, env, trfun, e1) = rename 1000 e02 in
    let (e1s, defs) = remsign (trfun e1) in
    let (e1q, u1q) = remzf e1s u1 in
    let e1c = remclass e1q in
    let (e2, u2) = constrtr e1c u1q in
    let (e2z, u2z) = remlazy e2 u2 in
    let (e3, u3) = remmatch e2z u2z in
    let errs = map (errors errmap) [e1; e1s; e1c; e2; e3] in
    let e4 = trfun (remdeep e3) in
    let E01 = Ecnv e4 in
    let E02 = if NoUnrec then E01 else unrec E01 in
    let E0 = if autoexp then
	case E02 in
	   Emodule i _ bs : Emodule i (map (mkexpid o fst) (conc bs)) bs
	end
	else E02
    in
    let (terr, S, E1, _, u4) = if all null errs then tcheck errmap E0 defs u3
			else ([], fail "_", E0, fail "_", u3) in
    let E11 = apconv E1 in
    let E12 = classtrans E11 in
    let E2 = conv E12 in
    let E3 = econv E2 in
    let (Bind b e) = abstract E3 in
    let emsg = getemsg (errs @ [terr]) in
/*trace ("icomp returns "@show_pair (show_string, show_Cexpr) (emsg, Bind b e))*/
    (emsg, Bind b e)
and     getemsg [] = []
||      getemsg ([].r) = getemsg r
||      getemsg (a._) = head 2000 (concmap (\e.e@"\n") a)
and conv e = (f e
where rec f (Emodule i expl ds) = Emodule i expl (map (mapsnd f) ds)
||        f (Ecase e ps d) = Ecase (f e) (mapthd f ps) (f d)
||        f (Elet false ds e) =	ap (lam (map fst ds) (f e)) (map (f o snd) ds)
||	  f (Elet true ds e) = f (lrec ds e)
||	  f (Econstr c es) = econstr c (map f es)
||	  f (Elam i e) = Elam i (f e)
||        f (Eap e1 e2) = Eap (f e1) (f e2)
||	  f (Eidapl i es) = ap (Evar i) (map f es)
||        f (Elamapl is e es) = ap (lam is (f e))  (map f es)
||	  f (e as Evar _) = e
||	  f (e as Efailmatch _) = e
||	  f (Einfo _ e) = f e
)
and ap e xs = reduce (\x.\r.Eap r x) e (rev xs)
and lam xs e = reduce Elam e xs
and lrec [(i,x)] e = Eap (Elam i e) (Eap EY (Elam i x))
||  lrec ds e =
	let n = length ds in
	let is = map fst ds
	and es = map snd ds
	and t = mkid IDTMP "Pt" idi_udef noorigname
	and c = tup n
	in
	Eap EY (Elam t (Econstr c (map (\e.Ecase (Evar t) [(c, is, e)] (Efailmatch 0)) es)))
and tup n = 
	let t = Ttuple n
	and na = tupstr n
	and tb = combine ((tvars n), (f where rec f=false.f)) 
	in
	Cconstr na
		t
		(mktinfo t 1 false false [mkcons (fail "tup") tb])
		0 
		tb
and EY = Evar (mkid IDY "PY" idi_udef noorigname)
and econstr c es = Econstr c es
end
